<template>
  <v-row>
    <v-col>
      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="AirportListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template v-if="!query" #append-inner>
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddAirportBtn" @click="createAirport()">
          <v-icon left>add</v-icon>
          Ajouter un aéroport
        </v-btn>
      </div>

      <v-data-table :headers="headers" :items="airportsPaginated" :server-items-length="airports.length"
        hide-default-footer :row-props="rowDisabledClass" density="compact" loading-text="Chargement des aéroports ..."
        no-results-text="Aucun aéroport ne correspond à cette recherche"
        no-data-text="Aucun aéroport ne correspond à cette recherche" class="airvam-table">

        <template #item.actions="{ item }">
          <div class="d-flex">
            <v-btn icon size="x-small" data-cy="EditAirportBtn" class="mr-1 action" flat @click="askEditAirport(item)">
              <v-icon>edit</v-icon>
            </v-btn>

            <v-btn icon size="x-small" class="action" data-cy="DeleteAirportBtn" flat
              @click="askActivateDeactivateAirport(item)">
              <v-icon v-if="!item.disabled">delete</v-icon>
              <v-icon v-if="item.disabled">settings_backup_restore</v-icon>
            </v-btn>
          </div>
        </template>
      </v-data-table>

      <div v-if="airports" class="pt-2 mb-4">
        <v-pagination v-model="currentPage" :total-visible="7" :length="totalPages" rounded="circle" density="comfortable">
        </v-pagination>
      </div>

      <LazyAdminAirportsAirportDialog v-if="airportDialog && editedAirport" v-model="airportDialog"
        :airport="editedAirport" @confirm="createEditAirport" @close="close" />

      <LazyConfirmDialog v-if="airportDialogActivateDeactivate" v-model="airportDialogActivateDeactivate"
        :dialog-text="airportDialogActivateDeactivateText" :dialog-title="airportDialogActivateDeactivateTitle"
        @confirm="activateDeactivateAirport" @close="close" />
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { debounce, editList } from "../../mixins/utilsMixin";
import { Airport } from "~/dto/airport.dto";

const { $api, $toast } = useNuxtApp();
const store = useStore();
const { airports } = storeToRefs(useStore());

const airportDialog = ref(false);
const airportDialogActivateDeactivate = ref(false);
const airportDialogActivateDeactivateTitle = ref('');
const airportDialogActivateDeactivateText = ref('');
const editedAirport: Ref<Airport | null> = ref(null);
const currentPage = ref(1);
const airportsPaginated: Ref<Airport[]> = ref([]);
const query = ref('');
const totalPages = ref(0);
const headers: Ref<any[]> = ref([
  { title: 'OACI', value: 'oaci', },
  { title: 'IATA', value: 'iata' },
  { title: 'Intitulé sur le billet d\'avion', value: 'name' },
  { title: 'Timezone', value: 'timezone' },
  { title: '', value: 'actions', sortable: false },
]);

const createAirport = () => {
  const airport = new Airport();
  askEditAirport(airport);
}

const askEditAirport = (item: Airport) => {
  editedAirport.value = { ...item };
  airportDialog.value = true;
}

const askActivateDeactivateAirport = (item: Airport) => {
  editedAirport.value = { ...item };
  airportDialogActivateDeactivateTitle.value = item.disabled ? `Activation d'un aéroport` : `Désactivation d'un aéroport`
  airportDialogActivateDeactivateText.value = item.disabled ? `Êtes-vous sûr de vouloir ré-activer l'aéroport "${editedAirport.value.oaci}" ?` : `Êtes-vous sûr de vouloir désactiver l'aéroport "${editedAirport.value.oaci}" ?`;
  airportDialogActivateDeactivate.value = true;
}

const close = () => {
  airportDialogActivateDeactivate.value = false;
  airportDialog.value = false;
  editedAirport.value = null;
}

const createEditAirport = async () => {
  try {
    const airportReturned = editedAirport.value?.id ? await $api.airport.update(editedAirport.value, editedAirport.value.id.toString()) : await $api.airport.create(editedAirport.value);
    await store.editList({ listName: 'airports', item: airportReturned });
    airportsPaginated.value = editList(airportsPaginated.value, airportReturned);
    $toast.success(editedAirport.value?.id ? "Aéroport modifié" : "Aéroport crée");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedAirport.value?.id ? "Erreur lors de l'édition d'un aéroport" : "Erreur lors de la création d'un aéroport");
  }
  paginate();
  close();
}

const activateDeactivateAirport = async () => {
  try {
    const airportReturned = (editedAirport.value?.disabled && editedAirport.value?.id) ? await $api.airport.activate(editedAirport.value.id.toString()) : await $api.airport.delete(editedAirport.value!.id.toString());
    await store.editList({ listName: 'airports', item: airportReturned });
    airportsPaginated.value = editList(airportsPaginated.value, airportReturned);
    $toast.success(airportReturned.disabled ? "Aéroport désactivé" : "Aéroport ré-activé");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedAirport.value?.disabled ? "Erreur lors de la ré-activation d'un aéroport" : "Erreur lors de la désactivation d'un aéroport");
  }
  paginate();
  close();
}

const rowDisabledClass = ({ item }: { item: Airport }) => {
  return item.disabled ? { class: "disabled" } : undefined;
}

const paginate = () => {
  const airportsFiltered = [...airports.value].filter(a => {
    if (!query.value || query.value === '') {
      return true;
    }
    return a.oaci?.toUpperCase().includes(query.value.toUpperCase())
      || a.iata?.toUpperCase().includes(query.value.toUpperCase())
      || a.name?.toUpperCase().includes(query.value.toUpperCase())
  });
  const index = (currentPage.value - 1) * 20;
  airportsPaginated.value = airportsFiltered.slice(index, index + 20);
  totalPages.value = Math.ceil(airportsFiltered.length / 20);
}

paginate();

watch(query, debounce(function () {
  paginate();
}, 300));

watch(currentPage, () => paginate());

</script>
